/* hdup header file
 *
 * Author: Miek Gieben
 * Date: Wed, 27 feb, 2002
 */

#include<stdio.h>
#include<stdlib.h>
#include<stdarg.h>
#include<unistd.h>
#include<string.h>
#include<ctype.h>
#include<pwd.h>
#include<time.h>
#include<glob.h>
#include<sys/stat.h>
#include<sys/types.h>
#include<sys/wait.h>

#define PROGNAME   "hdup"
#define VERSION    "1.0.2-stable"
#define TMPDIR     "/tmp/hdup"
#define TAR        "/bin/tar"
#define MCRYPT     "/usr/bin/mcrypt"
#define MDECRYPT   "/usr/bin/mdecrypt"
#define SCP        "/usr/bin/scp"
#define MAXPATHLEN 256
#define OVERVIEW   50
#define MAXDIR     10
#define MAXHOST    5
#define DOTEND     13

#define FILELIST    "/filelist"
#define EXCLUDELIST "/excludelist"
/*#define DEBUG */

#define TAR_NONE   "cpf"
#define TAR_GZIP   "cpfz"
#define TAR_BZIP   "cpfj"
#define TAR_BZIPO  "cpfI"

#define DAILY   0
#define WEEKLY  1
#define MONTHLY 2
#define REMOTE  3
#define RESTORE 4

#define LOCK    0
#define UNLOCK  1

#define GIGABYTE 1073741824
#define MEGABYTE 1048576
#define KILOBYTE 1024
#define SECDAY   86400

#define PREV       -1
#define NEXT       1
#define MAXRESTORE 100
#define NONE       0
#define NONE_EXT   ".tar"
#define GZIP       1
#define GZIP_EXT   ".tar.gz"
#define BZIP       2
#define BZIP_EXT   ".tar.bz2"
#define BZIPO      3
#define BZIPO_EXT  ".tar.bz2"
#define MCRYPT_EXT ".nc"

#define KEY_BACKUP  0
#define KEY_EXCLUDE 1
#define KEY_REMOTE  2
/* the number of keywords */
#define KEYWORDS    3

struct option_t {
        unsigned int remove  :1;
        unsigned int help    :1;        
        unsigned int verbose :1;        
        unsigned int oldtar  :1;
        char *tar;
        char *alg;
        char *keypath;
        char *configpath;
        char *identity;
        char *user;
        char *scp_user;
};

struct argument_t {
        int scheme;
        char *host;
        char *date;
        char *extractdir;
};

/* hold all the info about a specific host */
struct host {
        char *name;
        char *path[MAXDIR];
        char *exclude[MAXDIR];
        char *user;
        char *scp_user;
        char *identity;
        char *keypath;
        char *alg;
        char *configpath;
        char *remote_host;
        char *remote_path;
        char *tar_opt;
        char *date;
        char *basename;
        char *dirname_date;
        char *dirname_etc;
        char *filelist;
        char *excludelist;
        char *inclist;
        char *archivename;
        unsigned int remove;
        unsigned int oldtar;
};

extern unsigned int quiet;
extern char *scheme[];
extern char *keyword[];
extern char *dots;
extern char *spaces;
typedef struct host host_t;
typedef struct host * phost_t;
